
// rssgs_generating_iq_modulated_signal_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rssgs_generating_iq_modulated_signal_example.h"
#include "rssgs_generating_iq_modulated_signal_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define CHECKERR(fcal) if ((rssgs_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crssgs_generating_iq_modulated_signal_exampleDlg dialog




Crssgs_generating_iq_modulated_signal_exampleDlg::Crssgs_generating_iq_modulated_signal_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crssgs_generating_iq_modulated_signal_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_RFFrequency(1000000)
	, m_Level(-10)
	, m_IOffset(0)
	, m_QOffset(0)
	, m_QuadratureOffset(0)
	, m_GainImbalanceIn(0)
	, m_GainImbalanceOut(0)
	, m_RFOutput(FALSE)
{
	m_InstrSession = NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crssgs_generating_iq_modulated_signal_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RF_FREQUENCY, m_RFFrequency);
	DDX_Text(pDX, IDC_LEVEL, m_Level);
	DDX_Text(pDX, IDC_I_OFFSET, m_IOffset);
	DDX_Text(pDX, IDC_Q_OFFSET, m_QOffset);
	DDX_Text(pDX, IDC_QUADRATURE_OFFSET, m_QuadratureOffset);
	DDX_Text(pDX, IDC_GAIN_IMBALANCE_IN, m_GainImbalanceIn);
	DDX_Text(pDX, IDC_GAIN_IMBALANCE_OUT, m_GainImbalanceOut);
	DDX_Check(pDX, IDC_RF_OUTPUT, m_RFOutput);
}

BEGIN_MESSAGE_MAP(Crssgs_generating_iq_modulated_signal_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crssgs_generating_iq_modulated_signal_exampleDlg::OnBnClickedStart)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// Crssgs_generating_iq_modulated_signal_exampleDlg message handlers

BOOL Crssgs_generating_iq_modulated_signal_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crssgs_generating_iq_modulated_signal_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crssgs_generating_iq_modulated_signal_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crssgs_generating_iq_modulated_signal_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	/* initialize driver */
    CHECKERR (rssgs_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));

	CHECKERR (rssgs_SetOperationMode (m_InstrSession, RSSGS_OPERATION_MODE_NORMAL));
			
	CHECKERR (rssgs_SetFrequencyAndLevel (m_InstrSession, m_RFFrequency, m_Level));
	
	CHECKERR (rssgs_SetROSCSource (m_InstrSession, RSSGS_SOURCE_INT)); 
		
	CHECKERR (rssgs_SetFrequencyLocalOscillatorSource (m_InstrSession, RSSGS_SOURCE_INT));
		
	CHECKERR (rssgs_SetIQImpairmentsIOffset (m_InstrSession, m_IOffset));
		
	CHECKERR (rssgs_SetIQImpairmentsQOffset (m_InstrSession, m_QOffset));
	
	CHECKERR (rssgs_SetIQImpairmentsGainImbalance (m_InstrSession, m_GainImbalanceIn));
	
	CHECKERR (rssgs_GetIQImpairmentsGainImbalance (m_InstrSession, &m_GainImbalanceOut));
	
	CHECKERR (rssgs_SetIQImpairmentsQuadratureOffset (m_InstrSession, m_QuadratureOffset));
	
	CHECKERR (rssgs_SetIQWideband (m_InstrSession, VI_TRUE));
	
	CHECKERR (rssgs_SetIQImpairmentsState (m_InstrSession, VI_TRUE));
	
	CHECKERR (rssgs_SetRFState(m_InstrSession, m_RFOutput));
    
    UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	CHECKERR (rssgs_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crssgs_generating_iq_modulated_signal_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rssgs_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rssgs_error_message(m_InstrSession, rssgs_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rssgs_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rssgs_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}


void Crssgs_generating_iq_modulated_signal_exampleDlg::OnClose()
{
	cleanup(VI_FALSE);

	CDialog::OnClose();
}
